h = require('./helper.coffee')

FieldValidator = h.requireValidator('field')

describe "FieldValidator", ->
  describe "#test", ->
    it "fails if the field is not present on the object", (passValidator) ->
      validator = new FieldValidator('name', passValidator)

      h.testFail(validator, {}, 'Field name is not present on the object {}')

    it "fails when the validation fails on the field", (failValidator) ->
      validator = new FieldValidator('name', failValidator)

      h.testFail(validator, {name: 'User'}, 'Error on field name: failed')

    it "passes when the validation passes", (passValidator) ->
      validator = new FieldValidator('name', passValidator)

      h.testPass(validator, {name: 'User'})
      expect(passValidator.test.calledWith('User')).true

    describe "given the optional flag is passed", ->
      lazy "validator", (failValidator) -> new FieldValidator('name', failValidator, optional: true)

      it "skips the validation and passes if the field is not present", (validator) ->
        h.testPass(validator, {})

      it "still runs the validation when the field is present", (validator) ->
        h.testValidator validator, (pass, fail) ->
          fail({name: null})
          fail({name: undefined})
          fail({name: 'value'})